<?
/* 
   This file is part of the 'Science Fair In A Box' project
   SFIAB Website: http://www.sfiab.ca

   Copyright (C) 2005 Sci-Tech Ontario Inc <info@scitechontario.org>
   Copyright (C) 2005 James Grant <james@lightbox.org>
   Copyright (C) 2007 David Grant <dave@lightbox.org>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
?>
<?
 require_once("../common.inc.php");
 require_once("../user.inc.php");
 require_once("reports.inc.php");

 user_auth_required('committee');

 
 /* Load the user's volunteer position selections */

 $edit_mode = array_key_exists('edit', $_GET);

 $action = $_GET['action'];
 if($action=='') $action = $_POST['action'];

 if($action == 'unlink') {
 	$id = intval($_GET['id']);
	mysql_query("DELETE FROM reports_committee WHERE
			users_id='{$_SESSION['users_id']}' AND id='$id'");
	header("Location: committee_reports.php?edit=1");
	exit;
 }

 if($action == 'add') {
 	$reports_id = intval($_POST['reports_id']);
	/* reports_id might be < 0, that's ok */
	$category = mysql_escape_string(stripslashes($_POST['category']));
	$category_exist = mysql_escape_string(stripslashes($_POST['category_exist']));
	$comment = mysql_escape_string(stripslashes($_POST['comment']));

	if($category_exist != '') $category = $category_exist;
	
	$type = $_POST['type'];
	if(!array_key_exists($type, $report_options['type']['values'])) {
		/* Invalid format, not possible unless someone manually
		 * changes the POST variable */
		echo "Invalid format";
		exit;
	}
	$stock = $_POST['stock'];
	if(!array_key_exists($stock, $report_stock)) {
		/* Invalid format, not possible unless someone manually
		 * changes the POST variable */
		echo "Invalid stock";
		exit;
	}

	mysql_query("INSERT INTO `reports_committee` 
		(`id`, `users_id` , `reports_id` , `category` , `comment` , `format` , `stock`)
		VALUES (
			NULL , '{$_SESSION['users_id']}', 
			'$reports_id', '$category', '$comment', 
			'$type', '$stock' );");
	header("Location: committee_reports.php?edit=1");
 }


 //send the header
 if($edit_mode == false) {
	 send_header("My Reports", 
 			array("Committee Main" => "committee_main.php")
			);
 } else {
	 send_header("Edit My Reports", 
 			array("Committee Main" => "committee_main.php",
	 			"My Reports" => "admin/committee_reports.php")
			);
 }

 /* Load all the users reports */
 $q = mysql_query("SELECT reports_committee.*,reports.name
 			FROM reports_committee 
				LEFT JOIN reports ON reports.id=reports_committee.reports_id
 			WHERE users_id='{$_SESSION['users_id']}'
			ORDER BY category,id");
 echo mysql_error();
 if(mysql_num_rows($q) == 0) {
 	echo i18n('You have no reports saved');
 } else {
 	/* List each report with info */

	if($edit_mode == true) {
		echo i18n('Deleting all the reports from a category will also delete the category.');
		echo '<br />';
		echo '<br />';
		echo '<a href="committee_reports.php">'.i18n('Click here when you are finished editing your report list').'</a>';
		echo '<br />';
		echo '<br />';
	}

	echo '<table>';
	$last_category = '';

	while($i = mysql_fetch_object($q)) {
		if($last_category != $i->category) {
			/* New category */
			echo '<h4>';
			if($edit_mode == true) echo i18n('Category').': ';
			echo "{$i->category}</h4>";
			$last_category = $i->category;
		}
		if($i->reports_id > 0) $name = $i->name;
		else $name = $report_custom[-$i->reports_id]['name'];
		echo "<table><tr><td colspan=\"3\">$name</td>";
		echo "<tr><td width=\"20px\">";
		if($edit_mode == true) {
			echo "<a title=\"Remove Report\" href=\"committee_reports.php?action=unlink&id={$i->id}\"><img src=\"".$config['SFIABDIRECTORY']."/images/16/button_cancel.".$config['icon_extension']."\" border=\"0\" alt=\"Remove Report\" /></a>";
		}


		echo "</td>";
		echo "<td><span style=\"font-size: 0.75em;\">";
		if($i->reports_id > 0) {
			echo i18n('Format').": {$i->format}, ";
			echo i18n('Paper').": {$report_stock[$i->stock]['name']}, ";
			echo i18n('Year').": {$config['FAIRYEAR']}";
		} else {
			echo i18n('Custom report, no options available');
		}
		echo "</span></td>";
		echo "<td rowspan=\"2\">";
		if($edit_mode == false) {
			if($i->reports_id > 0) { 
				echo "<form method=\"get\" action=\"reports_gen.php\">";
				echo "<input type=\"hidden\" name=\"id\" value=\"{$i->reports_id}\" />";
				echo "<input type=\"hidden\" name=\"show_options\" value=\"1\" />";
			} else {
				$url = $report_custom[-$i->reports_id]['custom_url'];
				echo "<form method=\"post\" action=\"{$config['SFIABDIRECTORY']}/$url\">";
			}
			echo "<input type=\"submit\" value=\"".i18n('Generate')."\" /><br />";
			echo "</form>";
		}
		echo "</td></tr>";

		echo "<tr><td></td><td>{$i->comment}</td></tr>";
		echo "</table>";
	}
		
 }

 if($edit_mode == false) {
 	echo "<hr />";
	echo '<a href="committee_reports.php?edit=1">'.i18n('Click here to edit your Report List').'</a>';
 	send_footer();
	exit;
 }

 echo '<hr />';

 /* Load available reports */
 $reports = report_load_all();

 /* Create an add report box */
 echo '<h4>'.i18n('Add a Report to your Report List').'</h4>';
 echo "<form method=\"post\" action=\"committee_reports.php\">";
 echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
 echo "<table>\n";
 echo '<tr><td colspan="2">';
 echo "<select name=\"reports_id\">";
 $x=0;
 foreach($reports as $r) {
 	$x++;
	echo "<option value=\"{$r['id']}\">$x. {$r['name']}</option>";
 }
 $rid = -1;
 foreach($report_custom as $r) {
 	$x++;
	echo "<option value=\"$rid\">$x. {$r['name']}</option>";
	$rid--;
 }

 echo "</select></td></tr>";

 echo "<tr><td>Category:</td><td>";
 $q = mysql_query("SELECT DISTINCT category FROM reports_committee
 		WHERE users_id='{$_SESSION['users_id']}'
		ORDER BY category");

 echo "Existing Category: <select name=\"category_exist\">";
 echo "<option value=\"\">-- ".i18n('Use New Category')." --</option>";
 while($i = mysql_fetch_object($q)) {
 	echo "<option value=\"{$i->category}\">{$i->category}</option>";
 }
 echo "</select><br />";
 echo "OR New Category: <input type=\"text\" name=\"category\">";
 echo "</td></tr>";

 $option_keys = array('type','stock');
 foreach($report_options as $ok=>$o) {
 	if(!in_array($ok, $option_keys)) continue;
 	echo "<tr><td>{$o['desc']}:</td>";
	echo "<td><select name=\"$ok\" id=\"$ok\">";
	foreach($o['values'] as $k=>$v) {
		$sel = ($r['option'][$ok] == $k) ? 'selected=\"selected\"' : '';
		echo "<option value=\"$k\" $sel>$v</option>";
	}
	echo "</select></td></tr>";
 }
 echo "<tr><td>Comments:</td><td>";
 echo "<textarea rows=\"3\" cols=\"60\" name=\"comment\"></textarea></td></tr>";
 echo "<tr><td colspan=\"2\"><input type=\"submit\" value=\"Add Report to My Reports\" /></td></tr>";


 echo '</table></form>';



 echo '<hr />';
 echo '<h4>Descriptions for All Reports</h4>';
 echo i18n('Click on the report number to try the report with the default report options before you add it to your Report List');
 echo '<br /><br />';
 echo "<table>\n";
 $x=0;
 foreach(array_merge($reports, $report_custom) as $r) {
	$trclass = ($x % 2 == 0) ? "even" : "odd";
	$x++;
 	echo "<tr class=\"$trclass\">";
	if($r['custom_url'] == '') {
		$url = "admin/reports_gen.php?id={$r['id']}";
	} else {
		$url = $r['custom_url'];
	}
	echo "<td><a href=\"{$config['SFIABDIRECTORY']}/$url\">$x.</a></td>";
	echo "<td><table width=\"100%\"><tr>";

	echo "<td><b>{$r['name']}</b></td>";
	echo "<td align=\"right\">Created By: {$r['creator']}</td></tr>";
	echo "<tr><td colspan=\"2\">{$r['desc']}</td></tr>";
	echo "</table></tr>";
 }
	
echo "</table>";

 echo "<br />";

send_footer();
?>
